Index: /branches/UKMO/dev_3841_sbc/NEMOGCM/NEMO/OPA_SRC/SBC/cpl_oasis3.F90
===================================================================
--- /branches/UKMO/dev_3841_sbc/NEMOGCM/NEMO/OPA_SRC/SBC/cpl_oasis3.F90	(revision 4826)
+++ /branches/UKMO/dev_3841_sbc/NEMOGCM/NEMO/OPA_SRC/SBC/cpl_oasis3.F90	(revision 4827)
@@ -34,4 +34,5 @@
    USE in_out_manager               ! I/O manager
    USE lbclnk                       ! ocean lateral boundary conditions (or mpp link)
+   USE fld_def
 
    IMPLICIT NONE
@@ -46,6 +47,4 @@
 
    LOGICAL, PUBLIC, PARAMETER ::   lk_cpl = .TRUE.   !: coupled flag
-   INTEGER, PUBLIC            ::   OASIS_Rcv  = 1    !: return code if received field
-   INTEGER, PUBLIC            ::   OASIS_idle = 0    !: return code if nothing done by oasis
    INTEGER                    ::   ncomp_id          ! id returned by prism_init_comp
    INTEGER                    ::   nerror            ! return error code
@@ -62,7 +61,8 @@
    END TYPE FLD_CPL
 
-   TYPE(FLD_CPL), DIMENSION(nmaxfld), PUBLIC ::   srcv, ssnd   !: Coupling fields
+   TYPE(FLD_CPL), DIMENSION(nmaxfld), PUBLIC ::   ssnd   !: Coupling fields
 
    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::   exfld   ! Temporary buffer for receiving
+   INTEGER, PUBLIC :: localComm
 
    !!----------------------------------------------------------------------
@@ -106,5 +106,5 @@
 
 
-   SUBROUTINE cpl_prism_define( krcv, ksnd )
+   SUBROUTINE cpl_prism_define( krcv, ksnd, sd )
       !!-------------------------------------------------------------------
       !!             ***  ROUTINE cpl_prism_define  ***
@@ -115,5 +115,6 @@
       !! ** Method  :   OASIS3 MPI communication 
       !!--------------------------------------------------------------------
-      INTEGER, INTENT(in) ::   krcv, ksnd     ! Number of received and sent coupling fields
+      INTEGER, INTENT(in)                  ::   krcv, ksnd  ! Number of received and sent coupling fields
+      TYPE(FLD), INTENT(in), DIMENSION(:)  ::   sd          ! input field related variables
       !
       INTEGER :: id_part
@@ -187,17 +188,17 @@
       !
       DO ji = 1, krcv
-         IF ( srcv(ji)%laction ) THEN 
-            DO jc = 1, srcv(ji)%nct
-               IF ( srcv(ji)%nct .gt. 1 ) THEN
-                  WRITE(zclname,'( a7, i1)') srcv(ji)%clname,jc
+         IF ( sd(ji)%loasis ) THEN 
+            DO jc = 1, sd(ji)%nct
+               IF ( sd(ji)%nct .gt. 1 ) THEN
+                  WRITE(zclname,'( a7, i1)') sd(ji)%clvar,jc
                ELSE
-                  zclname=srcv(ji)%clname
+                  zclname=sd(ji)%clvar
                ENDIF
                WRITE(numout,*) "Define",ji,jc,zclname," for",PRISM_In
-               CALL prism_def_var_proto ( srcv(ji)%nid(jc), zclname, id_part, (/ 2, 0/),   &
+               CALL prism_def_var_proto ( sd(ji)%nid(jc), zclname, id_part, (/ 2, 0/),   &
                     &                      PRISM_In    , ishape   , PRISM_REAL, nerror)
                IF ( nerror /= PRISM_Ok ) THEN
                   WRITE(numout,*) 'Failed to define transient ', ji, TRIM(zclname)
-                  CALL prism_abort_proto ( srcv(ji)%nid(jc), 'cpl_prism_define', 'Failure in prism_def_var')
+                  CALL prism_abort_proto ( sd(ji)%nid(jc), 'cpl_prism_define', 'Failure in prism_def_var')
                ENDIF
             END DO
@@ -256,5 +257,5 @@
 
 
-   SUBROUTINE cpl_prism_rcv( kid, kstep, pdata, kinfo )
+   SUBROUTINE cpl_prism_rcv( kstep, sd )
       !!---------------------------------------------------------------------
       !!              ***  ROUTINE cpl_prism_rcv  ***
@@ -263,8 +264,6 @@
       !!      like stresses and fluxes from the coupler or remote application.
       !!----------------------------------------------------------------------
-      INTEGER                   , INTENT(in   ) ::   kid       ! variable index in the array
       INTEGER                   , INTENT(in   ) ::   kstep     ! ocean time-step in seconds
-      REAL(wp), DIMENSION(:,:,:), INTENT(inout) ::   pdata     ! IN to keep the value if nothing is done
-      INTEGER                   , INTENT(  out) ::   kinfo     ! OASIS3 info argument
+      TYPE(FLD), INTENT(inout)                  ::   sd        ! input field related variables
       !!
       INTEGER                                   ::   jc        ! local loop index
@@ -274,37 +273,37 @@
       ! receive local data from OASIS3 on every process
       !
-      DO jc = 1, srcv(kid)%nct
-
-         CALL prism_get_proto ( srcv(kid)%nid(jc), kstep, exfld, kinfo )         
+      DO jc = 1, sd%nct
+
+         CALL prism_get_proto ( sd%nid(jc), kstep, exfld, sd%ninfo )         
          
          llaction = .false.
-         IF( kinfo == PRISM_Recvd   .OR. kinfo == PRISM_FromRest .OR.   &
-              kinfo == PRISM_RecvOut .OR. kinfo == PRISM_FromRestOut )   llaction = .TRUE.
-         
-         IF ( ln_ctl )   WRITE(numout,*) "llaction, kinfo, kstep, ivarid: " , llaction, kinfo, kstep, srcv(kid)%nid(jc)
+         IF( sd%ninfo == PRISM_Recvd   .OR. sd%ninfo == PRISM_FromRest .OR.   &
+              sd%ninfo == PRISM_RecvOut .OR. sd%ninfo == PRISM_FromRestOut )   llaction = .TRUE.
+         
+         IF ( ln_ctl )   WRITE(numout,*) "llaction, info, kstep, ivarid: " , llaction, sd%ninfo, kstep, sd%nid(jc)
          
          IF ( llaction ) THEN
             
-            kinfo = OASIS_Rcv
-            pdata(nldi:nlei, nldj:nlej,jc) = exfld(:,:)
+            sd%ninfo = OASIS_Rcv
+            sd%fnow(nldi:nlei, nldj:nlej,jc) = exfld(:,:)
             
             !--- Fill the overlap areas and extra hallows (mpp)
             !--- check periodicity conditions (all cases)
-            CALL lbc_lnk( pdata(:,:,jc), srcv(kid)%clgrid, srcv(kid)%nsgn )   
+            CALL lbc_lnk( sd%fnow(:,:,jc), sd%clvgrd, sd%nsgn )   
             
             IF ( ln_ctl ) THEN        
                WRITE(numout,*) '****************'
-               WRITE(numout,*) 'prism_get_proto: Incoming ', srcv(kid)%clname
-               WRITE(numout,*) 'prism_get_proto: ivarid '  , srcv(kid)%nid(jc)
+               WRITE(numout,*) 'prism_get_proto: Incoming ', sd%clvar
+               WRITE(numout,*) 'prism_get_proto: ivarid '  , sd%nid(jc)
                WRITE(numout,*) 'prism_get_proto:   kstep', kstep
-               WRITE(numout,*) 'prism_get_proto:   info ', kinfo
-               WRITE(numout,*) '     - Minimum value is ', MINVAL(pdata(:,:,jc))
-               WRITE(numout,*) '     - Maximum value is ', MAXVAL(pdata(:,:,jc))
-               WRITE(numout,*) '     -     Sum value is ', SUM(pdata(:,:,jc))
+               WRITE(numout,*) 'prism_get_proto:   info ', sd%ninfo
+               WRITE(numout,*) '     - Minimum value is ', MINVAL(sd%fnow(:,:,jc))
+               WRITE(numout,*) '     - Maximum value is ', MAXVAL(sd%fnow(:,:,jc))
+               WRITE(numout,*) '     -     Sum value is ', SUM(sd%fnow(:,:,jc))
                WRITE(numout,*) '****************'
             ENDIF
             
          ELSE
-            kinfo = OASIS_idle     
+            sd%ninfo = OASIS_idle     
          ENDIF
          
@@ -346,6 +345,8 @@
    !!----------------------------------------------------------------------
    USE in_out_manager               ! I/O manager
+   USE fld_def
    LOGICAL, PUBLIC, PARAMETER :: lk_cpl = .FALSE.   !: coupled flag
    PUBLIC cpl_prism_init
+   PUBLIC cpl_prism_rcv
    PUBLIC cpl_prism_finalize
 CONTAINS
@@ -355,4 +356,9 @@
       WRITE(numout,*) 'cpl_prism_init: Error you sould not be there...'
    END SUBROUTINE cpl_prism_init
+   SUBROUTINE cpl_prism_rcv ( kstep, sd )
+      INTEGER, INTENT(in   )   ::   kstep     ! ocean time-step in seconds
+      TYPE(FLD), INTENT(inout) ::   sd        ! input field related variables
+      WRITE(numout,*) 'cpl_prism_rcv: Error you sould not be there...'
+   END SUBROUTINE cpl_prism_rcv
    SUBROUTINE cpl_prism_finalize
       WRITE(numout,*) 'cpl_prism_finalize: Error you sould not be there...'
Index: /branches/UKMO/dev_3841_sbc/NEMOGCM/NEMO/OPA_SRC/SBC/fld_def.F90
===================================================================
--- /branches/UKMO/dev_3841_sbc/NEMOGCM/NEMO/OPA_SRC/SBC/fld_def.F90	(revision 4827)
+++ /branches/UKMO/dev_3841_sbc/NEMOGCM/NEMO/OPA_SRC/SBC/fld_def.F90	(revision 4827)
@@ -0,0 +1,107 @@
+MODULE fld_def
+   !!=====================================================================
+   !!                    ***  MODULE  fld_def ***
+   !! IOM variables definitions
+   !!====================================================================
+   !!--------------------------------------------------------------------
+   !!---------------------------------------------------------------------------------
+   !! NEMO/OPA 3.3 , NEMO Consortium (2010)
+   !! $Id: iom_def.F90 3680 2012-11-27 14:42:24Z rblod $ 
+   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
+   !!---------------------------------------------------------------------------------
+
+   USE par_kind
+
+   IMPLICIT NONE
+   PRIVATE
+
+   INTEGER, PUBLIC, PARAMETER ::   jp_wndi   =  1
+   INTEGER, PUBLIC, PARAMETER ::   jp_wndj   =  2
+   INTEGER, PUBLIC, PARAMETER ::   jp_otx1   =  3            ! 3 atmosphere-ocean stress components on grid 1
+   INTEGER, PUBLIC, PARAMETER ::   jp_oty1   =  4            ! 
+   INTEGER, PUBLIC, PARAMETER ::   jp_otz1   =  5            ! 
+   INTEGER, PUBLIC, PARAMETER ::   jp_otx2   =  6            ! 3 atmosphere-ocean stress components on grid 2
+   INTEGER, PUBLIC, PARAMETER ::   jp_oty2   =  7            ! 
+   INTEGER, PUBLIC, PARAMETER ::   jp_otz2   =  8            ! 
+   INTEGER, PUBLIC, PARAMETER ::   jp_itx1   =  9            ! 3 atmosphere-ice   stress components on grid 1
+   INTEGER, PUBLIC, PARAMETER ::   jp_ity1   = 10            ! 
+   INTEGER, PUBLIC, PARAMETER ::   jp_itz1   = 11            ! 
+   INTEGER, PUBLIC, PARAMETER ::   jp_itx2   = 12            ! 3 atmosphere-ice   stress components on grid 2
+   INTEGER, PUBLIC, PARAMETER ::   jp_ity2   = 13            ! 
+   INTEGER, PUBLIC, PARAMETER ::   jp_itz2   = 14            ! 
+   INTEGER, PUBLIC, PARAMETER ::   jp_qsroce = 15            ! Qsr above the ocean
+   INTEGER, PUBLIC, PARAMETER ::   jp_qsrice = 16            ! Qsr above the ice
+   INTEGER, PUBLIC, PARAMETER ::   jp_qsrmix = 17 
+   INTEGER, PUBLIC, PARAMETER ::   jp_qnsoce = 18            ! Qns above the ocean
+   INTEGER, PUBLIC, PARAMETER ::   jp_qnsice = 19            ! Qns above the ice
+   INTEGER, PUBLIC, PARAMETER ::   jp_qnsmix = 20
+   INTEGER, PUBLIC, PARAMETER ::   jp_qlw    = 21            !
+   INTEGER, PUBLIC, PARAMETER ::   jp_tair   = 22            !
+   INTEGER, PUBLIC, PARAMETER ::   jp_humi   = 23            !
+   INTEGER, PUBLIC, PARAMETER ::   jp_prec   = 24            !
+   INTEGER, PUBLIC, PARAMETER ::   jp_rain   = 25            ! total liquid precipitation (rain)
+   INTEGER, PUBLIC, PARAMETER ::   jp_snow   = 26            ! solid precipitation over the ocean (snow)
+   INTEGER, PUBLIC, PARAMETER ::   jp_tevp   = 27            ! total evaporation
+   INTEGER, PUBLIC, PARAMETER ::   jp_ievp   = 28            ! solid evaporation (sublimation)
+   INTEGER, PUBLIC, PARAMETER ::   jp_tdif   = 29            ! wind stress module
+   INTEGER, PUBLIC, PARAMETER ::   jp_taum   = 30            ! wind stress module
+   INTEGER, PUBLIC, PARAMETER ::   jp_w10m   = 31            ! 10m wind
+   INTEGER, PUBLIC, PARAMETER ::   jp_qtot   = 32   
+   INTEGER, PUBLIC, PARAMETER ::   jp_sbpr   = 33            ! sublimation - liquid precipitation - solid precipitation
+   INTEGER, PUBLIC, PARAMETER ::   jp_semp   = 34            ! solid freshwater budget (sublimation - snow)
+   INTEGER, PUBLIC, PARAMETER ::   jp_oemp   = 35            ! ocean freshwater budget (evap - precip)
+   INTEGER, PUBLIC, PARAMETER ::   jp_rnf    = 36            ! runoffs
+   INTEGER, PUBLIC, PARAMETER ::   jp_cal    = 37            ! calving
+   INTEGER, PUBLIC, PARAMETER ::   jp_topm   = 38            ! topmeltn
+   INTEGER, PUBLIC, PARAMETER ::   jp_botm   = 39            ! botmeltn
+   INTEGER, PUBLIC, PARAMETER ::   jp_dqnsdt = 40            ! d(Q non solar)/d(temperature)
+   INTEGER, PUBLIC, PARAMETER ::   jp_co2    = 41
+   INTEGER, PUBLIC, PARAMETER ::   jpfld     = 41            ! total number of fields received
+
+   INTEGER, PUBLIC            ::   OASIS_Rcv  = 1    !: return code if received field
+   INTEGER, PUBLIC            ::   OASIS_idle = 0    !: return code if nothing done by oasis **USE FOR FLDREAD TOO?**
+
+   TYPE, PUBLIC ::   FLD_N      !: Namelist field informations
+      CHARACTER(len = 256) ::   clname      ! generic name of the NetCDF flux file
+      CHARACTER(len = 32)  ::   clvgrd      ! grids on which is located the fields
+      CHARACTER(len = 32)  ::   clcat       ! multiple ice categories strategy
+      INTEGER              ::   nfreqh      ! frequency of each flux file
+      CHARACTER(len = 34)  ::   clvar       ! generic name of the variable in the NetCDF flux file
+      LOGICAL              ::   ln_tint     ! time interpolation or not (T/F)
+      LOGICAL              ::   ln_clim     ! climatology or not (T/F)
+      CHARACTER(len = 8)   ::   cltype      ! type of data file 'daily', 'monthly' or yearly'
+      CHARACTER(len = 34)  ::   wname       ! generic name of a NetCDF weights file to be used, blank if not
+      CHARACTER(len = 34)  ::   vcomp       ! symbolic component name if a vector that needs rotation
+      !                                     ! a string starting with "U" or "V" for each component   
+      !                                     ! chars 2 onwards identify which components go together  
+   END TYPE FLD_N
+
+   TYPE, PUBLIC ::   FLD        !: Input field related variables
+      CHARACTER(len = 256)            ::   clrootname   ! generic name of the NetCDF file
+      CHARACTER(len = 256)            ::   clname       ! current name of the NetCDF file
+      LOGICAL                         ::   loasis       ! field from OASIS or not (T/F)
+      LOGICAL                         ::   lfile        ! field from file or not (T/F)
+      CHARACTER(len = 32)             ::   clvgrd       ! grids on which is located the fields
+      INTEGER                         ::   nct          ! number of ice categories
+      INTEGER                         ::   nfreqh       ! frequency of each flux file
+      CHARACTER(len = 34)             ::   clvar        ! generic name of the variable in the NetCDF flux file
+      LOGICAL                         ::   ln_tint      ! time interpolation or not (T/F)
+      LOGICAL                         ::   ln_clim      ! climatology or not (T/F)
+      CHARACTER(len = 8)              ::   cltype       ! type of data file 'daily', 'monthly' or yearly'
+      INTEGER                         ::   num          ! iom id of the jpfld files to be read
+      INTEGER , DIMENSION(2)          ::   nrec_b       ! before record (1: index, 2: second since Jan. 1st 00h of nit000 year)
+      INTEGER , DIMENSION(2)          ::   nrec_a       ! after  record (1: index, 2: second since Jan. 1st 00h of nit000 year)
+      REAL(wp) , ALLOCATABLE, DIMENSION(:,:,:  ) ::   fnow       ! input fields interpolated to now time step
+      REAL(wp) , ALLOCATABLE, DIMENSION(:,:,:,:) ::   fdta       ! 2 consecutive record of input fields
+      CHARACTER(len = 256)            ::   wgtname      ! current name of the NetCDF weight file acting as a key
+      !                                                 ! into the WGTLIST structure
+      CHARACTER(len = 34)             ::   vcomp        ! symbolic name for a vector component that needs rotation
+      REAL(wp)                        ::   nsgn         ! Control of the sign change
+      LOGICAL, DIMENSION(2)           ::   rotn         ! flag to indicate whether before/after field has been rotated
+      INTEGER                         ::   nreclast     ! last record to be read in the current file
+      INTEGER, DIMENSION(9)           ::   nid          ! OASIS id of the field (no more than 9 categories)
+      INTEGER                         ::   ninfo        ! OASIS recv info
+   END TYPE FLD
+
+   !!=====================================================================
+END MODULE fld_def
